<?php

namespace FiloBlu\Refilo\Model\Indexer\Provider;

use FiloBlu\Refilo\Model\Indexer\Core\Provider\QueryProviderInterface;
use Magento\Framework\App\ResourceConnection;

class RegionsProvider implements QueryProviderInterface
{
    /** @var null */
    protected $ids = null;
    /** @var int */
    protected $website;
    /** @var ResourceConnection */
    private $resourceConnection;
    /** @var array */
    private $bindings = [];
    /**
     * @var int
     */
    protected $store_id;

    /**
     * PriceProvider constructor.
     * @param ResourceConnection $resourceConnection
     */
    public function __construct(
        ResourceConnection $resourceConnection
    ) {
        $this->resourceConnection = $resourceConnection;
    }

    public function getQuery(): string
    {
//        $connection = $this->resourceConnection->getConnection();
//
//        $select = $connection->select();
//        $select->from(
//            'directory_country_region'
//        );

//        return $select->__toString();

        return 'SELECT
    region_id as id,
    CONCAT(\'geocountry_\',country_id) as _id, code, default_name as name
FROM
    directory_country_region';
    }

    public function getBindings(): array
    {
        return $this->bindings;
    }

    public function filter(array $ids): QueryProviderInterface
    {
        $this->ids = $ids;
        return $this;
    }

    public function website(int $website_id): QueryProviderInterface
    {
        $this->website = $website_id;
        return $this;
    }

    public function store(int $store_id): QueryProviderInterface
    {
        $this->store_id = $store_id;
        return $this;
    }
}
